#-----------------------------------------------------------------------------
# Author:      Song Huang
#
# Created:     2004/10/01
# Copyright:   (c) 2004 ossacc.org
# License:     GPL
#-----------------------------------------------------------------------------

"""
CMF SubSitePetition Installation script

 id:            cmf_install_subsitepetition
 title:         
 module name:   SubSitePetitionTool.Install
 function name: install
"""

from cStringIO import StringIO
#from OFS.Folder import manage_addFolder
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.SubSitePetitionTool import subsitepetition_globals
from Products.SubSitePetitionTool.SubSitePetitionTool import SubSitePetitionTool
from Products.SubSitePetitionTool.SubSitePetitionTool import SubSiteFolder

def install(self):
    """
    Install sub site petition tool to plone site
    """
    # if inside subsitefolder
    if getattr(self, 'inSubSiteFolder', None):
        return 'Inside of the Sub Site Folder!'

    out = StringIO()  
    # add sub site petition tool
    sspt=SubSitePetitionTool()
    self._setObject('portal_subsitepetition',sspt,set_owner=0)
    out.write("Added sub site petition tool to self.\n")
    # make subsite folder
    root = self.getPhysicalRoot()
    objids = root.objectIds()
    if sspt.subsitefolder in objids:
        for i in range(1,20):
            ssf = sspt.subsitefolder + '_%2.2d' % i
            if ssf not in objids:
                break
        sspt.subsitefolder = ssf
    ssf = SubSiteFolder(sspt.subsitefolder)
    ssf.title = 'Sub Site'
    root._setObject(sspt.subsitefolder, ssf)
    out.write("Added sub site folder to self.\n")
    # add skin
    skinstool = getToolByName(self, 'portal_skins')
    skin_name = 'subsitepetition'
    if skin_name not in skinstool.objectIds():
        addDirectoryViews(skinstool, 'skins', subsitepetition_globals)
    for skinName in skinstool.getSkinSelections():
        path = skinstool.getSkinPath(skinName) 
        path = [i.strip() for i in  path.split(',')]
        if skin_name not in path:
            path.append(skin_name)
        path = ','.join(path)
        skinstool.addSkinSelection(skinName, path)
    out.write("Added subsitepetition DirectoryView to portal_skins.\n")
    # add portlet
    lslots = self.getProperty('left_slots', [])
    portlet = 'here/portlet_subsite/macros/portlet'
    if portlet not in lslots:
        lslots = lslots + (portlet,)
    self.manage_changeProperties({'left_slots': lslots})
    out.write("Added portlet_subsite to left_slots\n")
    #
    return out.getvalue()
