#-----------------------------------------------------------------------------
# Name:        config.py
#
# Author:      Song Huang
#
# Created:     2004/09/21
# Copyright:   (c) 2004 ossacc.org
# License:     GPL
#-----------------------------------------------------------------------------

import os

#------------------------
# Apache setup
# requirement: 
#   1. mod_write, 
#   2. mod_proxy, 
#   3. and create a Virtual Host Monster object in your zope's ZMI root.
#      If you don't switch on apache virtual host setting, You must to setup 
#      the VHM object to handles virtual host mechanism.
# 1:switch on, 0:turn off.
SETUP_APACHE = 1

# Apache controller.
# NOTE: you need to setting sudoers to allow zope's process owner to run 
#   the controller. ex., if zope process owner is apache, add below 2 lines
#   to /etc/sudoers use the "visudo" command.
# Cmnd_Alias WEBCMD = /etc/init.d/httpd
# apache  ALL = NOPASSWD: WEBCMD
APACHE_CTRL = '/etc/init.d/httpd'

# add the line below to httpd.conf after VirtualHost segment:
# "include /etc/httpd/conf/vh.d"
# if the folder not exist, pls make it!
APACHE_VH_FOLDER = '/etc/httpd/conf/vh.d'

# VirtualHost_SETTING % (serveradmin, domain_name, domain_name, ssPath)
#   serveradmin = petition's e_mail
#   domain_name = petition's (domain_name + base_name)
#   ssPath = /portal.getPhysicalPath()/SubSite/p.storageId/p.id
VH_SETTING = """<VirtualHost *:80>
    ServerAdmin %s
    ServerName %s

    RewriteEngine On
    RewriteRule ^/(.*) http://localhost:8080/VirtualHostBase/http/%s:80%s/VirtualHostRoot/$1 [P]
</VirtualHost>
"""

#------------------------
# DDNS update
# If you haven't DDNS server, you must setting SETUP_DDNS to 0, and you must
#     manual settiing domain name.
# 1:switch on, 0:turn off.
SETUP_DDNS = 1

# you needed setup a DDNS server and allow from this machine to update.
DDNS_SERVER = '127.0.0.1'

# time to live by second
DDNS_TTL = '10800' # = 3 hours

# the http host listen ip
HOST_IP = '61.219.18.103'

#------------------------
# Virtual Host Storage setting
# Add new setting to zope.conf
# 
# 50 MB = 52428800 bytes
DEF_QUOTA = '52428800'

# Zope Instance home
INSTANCE_HOME = os.environ.get('INSTANCE_HOME', '')

# ZopeStorage_SETTING % ( sid, sid, DEF_QUOTA, SSabsPath, sid )
ZS_SETTING = """<zodb_db %s>
    <filestorage>
      path $INSTANCE/var/subsite/%s.fs
      quota %s
    </filestorage>
    mount-point %s/%s
</zodb_db>
"""
