from interface import Interface, Attribute

class ISubSitePetitionTool(Interface):
    ''' the SubSitePetition Tool
        contains 'Petition' and 'Storage' instances
    '''

    id = Attribute('id', 'Must be set to "portal_subsitepetition"')

    def isDomainAvailable(dm):
        ''' determines the domain name is available '''

    def listPetitions(skipReject=1):
        ''' list pending sub site petition for review -> list of dicts with
            keys:(id,name,description)'''

    def listRejecteds(deadline=30):
        ''' list rejected petition in 30 days -> list of dicts with
            keys:(id,status,description)'''

    def listAlloweds():
        ''' returns a list of sub site that were running -> list of dicts with
            keys:(id,status,webalizerURL)'''

    def newId():
        ''' return a petition's id for createPetiton function ->
            current time for second + random numeral '''

    def createPetition(id,name="",company="",title="",zip="",address="",
                 telno="",e_mail="",description="",domain_name="",skin=""):
        ''' create a petition '''

    def confirmPetition(checksum):
        ''' confirm petition by checksum '''

    def RejectPetition(id):
        ''' Reject petition by id. '''

    def AllowPetition(id):
        ''' allow petition by id. '''

    def AllowPetitions(self, ids):
        ''' allow petition by ids. '''

    def newSubSite(p):
        ''' create sub site with petiton '''

    def listScreenshots(self):
        ''' return the screenshots name list '''

    def getScreenshot(self,name):
        ''' return the image object '''

class IPetition(Interface):
    ''' represents the petitions is contained inside the SubSitePetitionTool '''

    id = Attribute('id', 'Must be the current time with second and an random numeral.')

    name = Attribute('types', 'default: ""')
    company = Attribute('types', 'default: ""')
    title = Attribute('types', 'default: ""')
    zip = Attribute('types', 'default: ""')
    address = Attribute('types', 'default: ""')
    telno = Attribute('types', 'default: ""')
    e_mail = Attribute('types', 'default: ""')
    description = Attribute('types', 'default: ""')
    domain_name = Attribute('types', 'default: ""')
    skin = Attribute('types', 'default: ""')
    # status == 0:waiting-confirm 1:rejected, 2:pending, 3:allowed
    status = Attribute('types', 'default: ""')
    modified = Attribute('types', 'default: [{"uid":uid, "time": time}, ]')

    def __init__(id,name="",company="",title="",zip="",address="",
                 telno="",e_mail="",description="",domain_name="",skin=""):
        ''' constructor '''

    def update(name="",company="",title="",zip="",address="",
        telno="",e_mail="",description="",domain_name="",skin=""):
        ''' updates the petition attributes '''

    def log(logmsg):
        ''' adds a log to the transcript '''

    def isWaitConfirm(p):
        ''' determines if the petition is wait to confirm '''

    def isPending():
        ''' determines if the petition is pending '''

    def isRejected():
        ''' determines if the petition is rejected '''

    def isAllowed():
        ''' determines if the sub site was running '''

    def setPending():
        ''' set the petition's status to pending '''

    def setReject():
        ''' set the petition's status to rejected '''

    def setAllow():
        ''' set the petition's status to allowed '''

class IStorage(Interface):
    ''' represents the storage is contained inside the SubSitePetitionTool '''


    id = Attribute('id', 'Must be serial numeral.')

    petitionId = Attribute('types', 'default: ""')

    def __init__(newid, petitionId):
        ''' constructor '''
    
    def isAvailable():
        ''' if not regester petitionId '''
        
    def isUsed():
        ''' if regester petitionId '''
        
    def regesterPI(pi):
        ''' regester petitionId '''
